#lang "fb"
#include once "fbgfx.bi"
	declare sub clock(byref GS as integer)

	declare sub cinput(byref C as string,byref X as integer,byref Y as integer,byref XX as integer,byref YY as integer)
	
	declare sub loadmem(fn as string,w as integer,h as integer,byref buffer as fb.Image Ptr)
	declare sub loadmap(fn as string,w as integer,h as integer,MAP() as integer)
	
	declare sub readmap(MAP() as integer,X as integer,Y as integer)
	declare sub drawmap(MAP() as integer,X as integer,Y as integer)

	declare sub fivethou(byref x as integer,byref y as integer,xx as integer,yy as integer, COND() as integer)

	const data_path="datapack/"
	const graphics_path="graphics/"
	const maps_path="maps/"
	const style=&h5555
	'brick03.mem
	Dim shared As fb.Image Ptr GA
	GA = ImageCreate(16, 16, 0)
	
	'flame01.mem
	Dim shared As fb.Image Ptr GB
	GB = ImageCreate(16, 16, 0)
	
	'flame02.mem
	Dim shared As fb.Image Ptr GC
	GB = ImageCreate(16, 16, 0)
	
	'skull01.mem
	Dim shared As fb.Image Ptr GD
	GD = ImageCreate(16, 16, 0)
	
	'dereck1.mem
	Dim shared As fb.Image Ptr GR
	GR = ImageCreate(16, 16, 0)
	
	'map002.mem
	'Dim shared As fb.Image Ptr GM
	'GM = ImageCreate(64, 32, 0)
		
	REDIM SHARED AS INTEGER MAP(0 to 63,0 to 31)	'visible map
	DIM SHARED AS INTEGER COND(1 TO 5)	'map logic
	
	dim shared as integer GS	'animation clock
	DIM AS INTEGER T,TT,R
	DIM AS STRING C,XM,YM
	DIM AS INTEGER X,Y,XX,YY,CURMAP
	DIM shared AS SINGLE START
	
	'KEY OFF
	ScreenRes 320, 200, 4, 8
	ScreenSet 1,0

	VIEW PRINT 1 TO 25
	COLOR 15, 0
	CLS
	'CURMAP = 2
	X = 2
	Y = 2

'GOSUB 2000

loadmem data_path+graphics_path+"brick03.mem",16,16,GA
loadmem data_path+graphics_path+"flame01.mem",16,16,GB
loadmem data_path+graphics_path+"flame02.mem",16,16,GC
loadmem data_path+graphics_path+"skull01.mem",16,16,GD
loadmem data_path+graphics_path+"dereck1.mem",16,16,GR
loadmap data_path+maps_path+"map002.mem",64,32,MAP()


do
	cinput C,X,Y,XX,YY
	clock GS
	fivethou x,y,x,yy,COND()
	
	IF X < 0 THEN X = 0 ELSE IF X > 319 THEN X = 319
	IF Y < 0 THEN Y = 0 ELSE IF Y > 199 THEN Y = 199


	COND(5)=0
	do while COND(5)=0
	
		cinput C,X,Y,XX,YY
		clock GS
		fivethou x,y,x,yy,COND()

		'ScreenCopy 2, 1
	
		'readmap MAP(),X,Y

		LINE (0, 0)-(319, 199), 0, BF, style
	
		drawmap MAP(),X,Y
		'fivethou x,y,x,yy,COND()
		
		LINE ((1 - 1) * 16, (1 - 1) * 16)-(15 * 16, 7 * 16), 15, B,style
	
		PUT ((8 - 1) * 16, (4 - 1) * 16), GR, OR	
	
		LOCATE 20,1:PRINT X;",";Y;
		LINE((8-1)*16-GS,(4-1)*16-GS)-(8*16+GS,4*16+GS),15,B,style

		ScreenCopy 1, 0
	
	loop
loop

sub clock(byref GS as integer)
	
	IF TIMER - START > .2 THEN

		START = TIMER
		GS = (GS+1) and 3

	end if

end sub

sub cinput(byref C as string,byref X as integer,byref Y as integer,byref XX as integer,byref YY as integer)
	
	dim as string XM,YM

	C = INKEY	
	XM = SPACE(0)
	YM = SPACE(0)

	IF LEN(C) = 0 THEN	
		C = SPACE(1)
	END IF
	
	IF C = CHR(27) THEN
		SCREEN 0, 0, 0, 0
		WIDTH 80
		COLOR 15, 1	', 1
		CLS
		END
	END IF
	
	XX = X
	YY = Y
	
	IF INSTR("123", C) > 0 THEN Y = Y + 1
	IF INSTR("789", C) > 0 THEN Y = Y - 1
	IF INSTR("369", C) > 0 THEN X = X + 1
	IF INSTR("147", C) > 0 THEN X = X - 1


end sub

sub loadmap(fn as string,w as integer,h as integer,MAP() as integer)

	dim as integer filemode,T,TT,R
	filemode=freefile
  
	open fn for input as #filemode
	
	FOR TT = lbound(MAP,2) TO ubound(MAP,2)
		FOR T = lbound(MAP,1) TO ubound(MAP,1)

			if not eof(filemode) then
				INPUT #filemode, R
				MAP(T, TT) = R
			end if
			
		NEXT T
	NEXT TT

	CLOSE filemode

end sub


sub loadmem(fn as string,w as integer,h as integer,byref buffer as fb.Image Ptr)

	buffer=ImageCreate(w, h)
	
	dim as integer filemode,T,TT,R
	filemode=freefile
  
  open fn for input as #filemode
	
	cls

	FOR TT = 0 TO h - 1
		FOR T = 0 TO w - 1
			
			IF NOT eof(filemode) then
				
				INPUT #filemode, R
				PSET (T, TT), R
			
			end if
			
		NEXT T
	NEXT TT

	CLOSE filemode

	GET (0, 0)-(w - 1, h - 1), buffer

end sub

sub readmap(MAP() as integer,X as integer,Y as integer)
	dim as integer T,TT

	ScreenCopy 2,1
	
	FOR TT = 1 TO 7
		FOR T = 1 TO 15	
			MAP(T, TT) = POINT(X + (T - 8), Y + (TT - 4))
		NEXT T
	NEXT TT
	
end sub

sub drawmap(MAP() as integer,X as integer,Y as integer)	
	dim as integer TX,TY,T,TT
	
	DIM AS INTEGER MAPCHUNK(0 TO 15,0 TO 7)
	
	FOR TT=1 TO 7
	FOR T=1 TO 15
		MAPCHUNK(T, TT) = MAP(X + (T - 8), Y + (TT - 4))
	NEXT T
	NEXT TT

	FOR TT=1 TO 7
	FOR T=1 TO 15

	if MAPCHUNK(T,TT)>0 then

	SELECT CASE MAPCHUNK(T,TT)
	
	CASE IS = 1	'brick
		
		SELECT CASE GS and 1
		CASE IS = 0 
			PUT ((T - 1) * 16, (TT - 1) * 16), GA
		
		CASE IS = 1
			PUT ((T - 1) * 16, (TT - 1) * 16), GA
		
		END SELECT
	
	CASE IS = 2	'flame
		
		SELECT CASE GS and 1
		CASE IS = 0 
			PUT ((T - 1) * 16, (TT - 1) * 16), GB
		
		CASE IS = 1
			PUT ((T - 1) * 16, (TT - 1) * 16), GC
		
		END SELECT
	
	CASE IS = 3	'flame
		
		SELECT CASE GS and 1
		CASE IS = 0 
			PUT ((T - 1) * 16, (TT - 1) * 16), GB
		
		CASE IS = 1
			PUT ((T - 1) * 16, (TT - 1) * 16), GC
		
		END SELECT
	
	CASE IS = 4	'skull
		
		SELECT CASE GS and 1
		CASE IS = 0 
			PUT ((T - 1) * 16, (TT - 1) * 16), GD
		
		CASE IS = 1
			PUT ((T - 1) * 16, (TT - 1) * 16), GD
		
		END SELECT
	
	CASE IS > 4
		LINE((T-1)*16,(TT-1)*16)-(T*16,TT*16),15,B,style
	
	END SELECT
	end if
	
	LINE((T-1)*16+4,(TT-1)*16+4)-(T*16-4,TT*16-4),7,B,style
	
	NEXT T
	NEXT TT
	
end sub
	

sub fivethou(byref x as integer,byref y as integer,xx as integer,yy as integer, COND() as integer)
	dim as integer t
	
	for t=1 to 5
		COND(t)=0
	next t	

	IF MAP(X,Y) >= 1 THEN
		COND(1) = 1
	else
		COND(1) = 0	
	END IF
	
	IF MAP(X,Y) <= 2 THEN
		COND(2) = 1
	else
		COND(2) = 0	
	END IF
	
	IF MAP(X,Y) = -1 THEN
		COND(3) = 1
	else
		COND(3) = 0	
	END IF	
	
	IF MAP(X,Y) = 4 THEN
		COND(4) = 1
	else
		COND(4) = 0	
	END IF
	
	COND(5)=(COND(1) AND COND(2)) OR COND(3) OR COND(4)

	IF (COND(5) and 1) THEN
		color 4
	end if
 	
	LOCATE 20,1:PRINT X;",";Y;
	LINE((8-1)*16-GS,(4-1)*16-GS)-(8*16+GS,4*16+GS),15,B,style
	
	IF (COND(5) and 1) THEN
		X = XX
		Y = YY
		
		for t=1 to 5
			COND(t)=0
		next t
		
		exit sub
	END IF
	
	for t=1 to 5
		COND(t)=0
	next t
	
end sub
